/***************************************************************************
 *   $Id: hash.h,v 1.1.1.1 2011-11-17 16:42:29 scg Exp $
 *                                                                         *
 *   (C)2011 St(u)dio of Computer Games                                    *
 *   Alexander Ozumenko <a.ozumenko@gmail.com>                             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef __HASH_H_
#define __HASH_H_


#include "list.h"



#define hash_get_entry(ptr, type, member) \
    ((type *)((char *)(ptr)-(unsigned long)(&((type *)0)->member)))



struct hash_entry {
    struct list_head list;
    const char *key;
};


struct hash {
    int m;
    struct list_head *table;
};



int hash_init(struct hash *h, int m);
void hash_release(struct hash *h, struct list_head *head);

void hash_clean(struct hash *h, struct list_head *head);

int hash_add(struct hash *h, const char *key, struct hash_entry *entry);
struct hash_entry *hash_get(struct hash *h, const char *key);
struct hash_entry *hash_del(struct hash *h, const char *key);



#endif /* __HASH_H_ */
