#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>

#include "htmltpl.h"



/**
 * Entry point
 */

int main(int argc, char *argv[]) {
    struct tpl *tpl;
    struct enviroment *env;
    struct variable *root, *var;
    int err;

    tpl = tpl_create();
    if(tpl == NULL) {
        fprintf(stderr, "Can't create pattern: %s\n", strerror(errno));
        return -1;
    }

    err = tpl_parse_file(tpl, TEST_TEMPLATE_FILENAME);
    if(err) {
        fprintf(stderr, "can't load pattern %s: %s\n", TEST_TEMPLATE_FILENAME,  tpl_error(tpl));
        return err;
    }

    env = tpl_get_enviroment(tpl);
    root = enviroment_get_root(env);

/*
FixMe: ввести дополнительное правило: если в блоке IF в имене - HASH, то поменять текущую переменную на этот HASH.
Либо ввести дополнтельный тэг <TMPL_SECTION NAME="">
Либо использовать тэг LOOP, но вместо массива назначать хеш
*/

    variable_hash_set(root,
        "title", variable_scalar(env, "Hello, World!"),
        "loop", variable_array(env,
            variable_hash(env,
                "title", variable_scalar(env, "title 1"), "link", variable_scalar(env, "title 1"),
                NULL),
            variable_hash(env,
                "title", variable_scalar(env, "title 2"), "link", variable_scalar(env, "title 2"),
                NULL),
            variable_hash(env,
                "title", variable_scalar(env, "title 3"), /*"link", variable_scalar(env, ""),*/
                NULL),
            variable_hash(env,
                "title", variable_scalar(env, "title 4"), "link", variable_scalar(env, "title 4"),
                NULL),
            variable_hash(env,
                "title", variable_scalar(env, "title 5"), "link", variable_scalar(env, "title 5"),
                NULL),
            NULL),
        NULL);

    // FixMe: анализируем возможные ошибки.
    err = enviroment_errno(env);
    if(err == 0) {
        tpl_output(tpl, stdout);
    }
    else {
        fprintf(stderr, "failed to set enviroment: %s\n", strerror(err));
    }

    tpl_release(tpl);

    return 0;
}
